<template>
<li class="header-notification">
    <a href="#!" class="waves-effect waves-light notif-icon">
        <i class="ti-bell"></i>
        <span v-if="(unread > 0)" class="badge bg-c-red"></span>
    </a>
    <ul class="show-notification">
        <li class="notif-header">
            <h6>Notifications </h6>
            <label class="label label-danger" v-if="(unread > 0)"> {{(unread > 0) ? unread : ''}} New</label>
        </li>
        <div class='notification-cards'>

            <li class="waves-effect waves-light" v-bind:class="checkIfSeen(userRole, notification.recipients)" v-for="notification in notifications" v-bind:key="notification._id" v-on:click="readNotification(notification._id, notification.recipients)">
                
                <div class="media">
                    <a v-bind:href="notification.service_request_url ? notification.service_request_url : 'javascript:void()'" class="w-100 d-flex">
                        <img class="d-flex align-self-center img-radius" v-bind:src="getUrl(notification.event)" alt="Generic placeholder image">
                        <div class="media-body">
                            <div class="d-inline">
                                <h5 class="notification-user d-inline" v-html="notification.title"></h5>
                                <label class="label label-default label-outline float-right"  v-if="typeof notification.ticket !== 'undefined'">Terminal {{notification.ticket.terminal_id}}</label>
                                <label class="label label-default label-outline float-right"  v-if="typeof notification.ticket !== 'undefined'">Outlet {{notification.ticket.outlet_id}}</label>
                            </div>                        
                            <p class="notification-msg" v-html="notification.message"></p>
                            <div class="row">
                                <div class="col-8">
                                    <span class="notification-time d-inline">
                                        <time-ago :refresh="60" :datetime="new Date(notification.created_at)"></time-ago> 
                                    </span>

                                </div>
                                <!-- <div class="col-4 text-right" v-if="(notification.type == 'manual') && (notification.noted != undefined)">
                                    <a v-bind:href="notification.service_request_url" class="btn btn-success btn-mini" v-if="(!containsKey(notification.noted, userId) && typeof notification.service_id !== 'undefined' )" v-on:click="noteThis(notification._id)">
                                        View Request
                                    </a>
                                    <i  class="ti-check" v-if="(containsKey(notification.noted, userId))"  ></i>
                                </div> -->
                            </div>
                        </div>
                    </a>
                </div>
            </li>
            <li class="waves-effect waves-light" v-if="(this.total > 5) && (this.showAll != 1)" v-on:click="showAllNotifications()">Show All</li>
        </div>
    </ul>
</li>

</template>

<script>
  import TimeAgo from 'vue2-timeago';
  import 'vue2-timeago/dist/vue2-timeago.css'
  export default {
  name: 'app',
  components: {
    TimeAgo,
  },
    //Required prop variables that should be pass on the vue component tag
    props: {
            'userId':{type: String,required: true},
            'userRole':{type: String,required: true}, 
            'userOutlets':{type: Array,required: true}
            },
    data: function() {
        return {
            notifications:[],
            broadcasted_events: [],
            to_be_saved: [],
            last_created: '',
            unread: 0,
            total: 0,
            showAll: 0,
            pathName: 'http://io.egms.macqalln.me/',
            event_variables: {
                        "lowbcf"  :  ["cashiers","csreps","finops","operators"],
                        "manual"  :  ["cashiers","csreps","finops","operators"],
                    }
        }
    },
    created: function(){
        this.subscribeTo();
    },
    methods:{
        containsKey(obj, key ) {
            console.log(obj, key);
            return Object.keys(obj).includes(key);
        },
        checkIfSeen(role, recipients){
            switch (role) {
                case 'cashiers':
                case 'operators':
                    return (recipients[this.userId].read_at != '') ? '' : 'new-notif';
                    break;
            
                default:
                    if(typeof recipients['all'][this.userId] === 'undefined'){
                        return 'new-notif';
                    }else{
                        return (recipients['all'][this.userId].read_at != '') ? '' : 'new-notif';
                    }
                    break;
            }
        },
        getUrl: function(event){
                switch (event) {
                    case 'lowbcf':
                        return this.pathName+'images/notification/lowbcf.png'
                        break;
                    case 'manual':
                        return this.pathName+'images/notification/manual.png'
                        break;
                
                    default:
                        return this.pathName+'images/notification/notification.png'
                        break;
                }
        },
        getHash: function(str){
            return Math.abs(str.split('').reduce((prevHash, currVal) =>
                (((prevHash << 5) - prevHash) + currVal.charCodeAt(0))|0, 0));
        },
        showAllNotifications: function(){
            this.showAll = 1;
            this.getNotifications('all');
        },
        saveNotification:function(obj){
            // if(obj != null){
            //     if( !(this.broadcasted_events.includes(obj.event_broadcast_id)) && this.last_created != obj.event_broadcast_id ){
                                
            //         axios({
            //             method: 'post',
            //             url: this.pathName+'api/notifications',
            //             data: obj
            //         }).then(response=>{
            //             this.broadcasted_events.push(obj.event_broadcast_id);
            //             this.last_created = obj.event_broadcast_id; 
            //         }).catch(function(error){
            //             console.log('erros : ',error);
            //         }) 
            //         this.showAll = 0;
            //         this.getNotifications();
            //     }
            // }
        },
        noteThis:function(id){
            var obj = {
                        '_id':id,
                        'user_id':this.userId,
                        'role':this.userRole,
                        'outlet_id':this.userOutlets
                      };
            axios({
                method: 'post',
                url: this.pathName+'api/send/notifications/manual/noted',
                data: obj
            }).then(response=>{
                if(response.response){
                    this.getNotifications();
                }
            }).catch(function(error){
                console.log('erros : ',error);
            }) 
        },
        readNotification:function(id, recipients){
            switch (this.userRole) {
                case 'cashiers':
                case 'operators':
                    var created_at = recipients[this.userId].read_at;
                    break;
            
                default:
                    if(typeof recipients['all'][this.userId] === 'undefined'){
                        
                        var created_at = '';
                    }else{
                        var created_at = recipients['all'][this.userId].read_at;
                    }
                    break;
            }

            var obj = {
                        '_id':id,
                        'user_id':this.userId,
                        'role':this.userRole,
                        'outlet_id':this.userOutlets
                      };
                      console.log(obj);
            if(created_at == ''){
                axios({
                    method: 'post',
                    url: this.pathName+'api/notifications/markasread',
                    data: obj
                }).then(response=>{
                    this.getNotifications();
                }).catch(function(error){
                    console.log('erros : ',error);
                }) 
            }
        },
        initiateSaving: function(){
            // var saveThese = JSON.parse(JSON.stringify(this.to_be_saved));
            // if(saveThese != []){                
            //     for (const key in saveThese) {
            //         if (saveThese.hasOwnProperty(key)) {
            //             const data = saveThese[key];
            //             this.saveNotification(data);
            //             delete saveThese[key];
            //         }
            //     }
            //     this.to_be_saved = [];
            // }
        },
        getNotifications:function(mode=null){

            if(mode == null && this.showAll == 0){
                var url = this.pathName+'api/notifications/user/'+this.userId+'?role='+this.userRole;
            }else{
                var url = this.pathName+'api/notifications/user/'+this.userId+'?role='+this.userRole+'&mode=all' ;
            }

            axios.get(url).then(response=>{
                this.notifications = response.data.result;
                this.unread = response.data.total_unread;
                this.total = _.size(response.data.total_msg);
            }).catch(function(error){
                console.log('erros : ',error);
            })  
        },
        addNotification: function(data, channel_name){
            if(data){
                //Save notification to DB
                data['recipient_id'] = this.userId;
                data['event_broadcast_id'] = this.getHash(JSON.stringify(data));
                this.showAll = 0;
                // this.to_be_saved.push(data);
                // this.initiateSaving();
                this.broadcastNotification(data);
            }
        },
        broadcastNotification: function(data){
            //Generate Web Browser API Notification interface
            Notification.requestPermission( permission => {
                let notification = new Notification( data.title, {
                    body: data.message, // content for the alert
                    icon: "https://pusher.com/static_logos/320x320.png" // optional image url
                });

                // link to page on clicking the notification
                notification.onclick = () => {
                    window.open(window.location.href);
                };
            });

            //Update Notification List
            this.getNotifications();


        },

        subscribeTo() {
            var channel = pusher.subscribe('notification');
            channel.unbind();
            var role = this.userRole;
            var outlets = this.userOutlets;
            var exclusive_events = [];

            for(var key in this.event_variables){
                if(this.event_variables[key].includes(role)){
                    exclusive_events.push(key);
                }
            }
            for(var event in exclusive_events){
                switch (role) {
                    case 'cashiers':
                    case 'operators':
                        if(_.size(outlets) > 0){
                            for(var outlet in outlets){
                                var event_channel = "notif_event="+exclusive_events[event]+"_outlet"+outlets[outlet];
                                channel.bind(event_channel, data => {
                                    if(typeof data.input != undefined){
                                        data = data.input;
                                    }
                                    this.addNotification(data, event_channel);
                                })
                            }
                        }else{
                            channel.bind("notif_event="+exclusive_events[event]+"_all", data => {
                                if(typeof data.input != undefined){
                                    data = data.input;
                                }
                                this.addNotification(data, event_channel);
                            })
                        }
                        break;
                    case 'finops':
                    case 'csreps':
                        var event_channel = "notif_event="+exclusive_events[event]+"_all";
                        channel.bind(event_channel, data => {
                            if(typeof data.input != undefined){
                                data = data.input;
                            }
                            this.addNotification(data, event_channel);
                        });
                        break;
                    default:
                        break;
                }
                
            };
        }
    },
    mounted:function(){
        this.getNotifications();
    },
    components: {
        TimeAgo,
    }
  }
</script>